; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                                                           =
; =             T E S T   P R O G R A M   F O R   W S P R I N T F             =
; =                                                                           =
; =                 MASM32 VERSION (C) 2008 BIGBOSS from COPS                 =
; =                                                                           =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                                                           =
; =                          Compiled with MASM32 v9                          =
; =                                                                           =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                                                           =
; = This program compares the wsprintf proto with _cpswsprintf proto.         =
; =                                                                           =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

.586
.model                      flat, stdcall                                      ; 32 bit memory model
option                      casemap : none                                     ; case sensitive

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                        A P I   P R O C E D U R E S                        =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
include                     \masm32\include\windows.inc
include                     \masm32\include\user32.inc
includelib                  \masm32\lib\user32.lib
include                     \masm32\include\kernel32.inc
includelib                  \masm32\lib\kernel32.lib
include                     inc\Timers.asm
include                     inc\_cpswsprintf.asm
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                             C O N S T A N T S                             =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.const
LOOP_COUNT                  equ    10000000

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                M A C R O S                                =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
literal                         Macro   quoted_text : VARARG
                                 local  local_text
                                 .data
                                 IfIDNI            <quoted_text>, <>
                                  local_text          db 0
                                 Else
                                  local_text          db quoted_text, 0
                                 EndIf
                                 .code
                                  ExitM               <local_text>
                                EndM

CTEXT                           Macro   quoted_text : VARARG
                                  ExitM               <offset literal(quoted_text)>
                                EndM

func                            Macro   parameters : VARARG
                                  invoke              parameters
                                  ExitM               <eax>
                                EndM

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                            P R O T O T Y P E S                            =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Init_Console                    Proto
Write_Console                   Proto   : PBYTE

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                 D A T A S                                 =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.data?
hConsoleOut                 HANDLE         ?                                   ; Console     : Handle for console output.
dConsoleRW                  dd             ?                                   ; Console     : Number of caracters read/written.
szBuffer                    TCHAR   MAX_PATH dup (?)                           ; Temp        : Temporary buffer.
szBuffer2                   TCHAR   MAX_PATH dup (?)                           ; Temp        : Temporary buffer.

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                  C O D E                                  =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.code
 start:
  invoke                    Init_Console
  invoke                    Write_Console, CTEXT('Comparator for standard wsprintf and _cpswsprintf.', 0Dh, 0Ah, 0Dh, 0Ah)
  ;
  ; String display test
  ;
  invoke                    Write_Console, CTEXT(' * parameters: CTEXT("%s"), CTEXT("PARAMETERS").', 0Dh, 0Ah)
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    wsprintf, offset szBuffer2, CTEXT("%s"), CTEXT("PARAMETERS")
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - wsprintf     : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    _cpswsprintf, offset szBuffer2, CTEXT("%s"), CTEXT("PARAMETERS")
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - _cpswsprintf : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  ;
  ; Signed number display test
  ;
  invoke                    Write_Console, CTEXT(' * parameters: CTEXT("%d"), -27194193.', 0Dh, 0Ah)
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    wsprintf, offset szBuffer2, CTEXT("%d"), -27194193
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - wsprintf     : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    _cpswsprintf, offset szBuffer2, CTEXT("%d"), -27194193
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - _cpswsprintf : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  ;
  ; Unsigned number display test
  ;
  invoke                    Write_Console, CTEXT(' * parameters: CTEXT("%u"), 123456789.', 0Dh, 0Ah)
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    wsprintf, offset szBuffer2, CTEXT("%u"), 123456789
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - wsprintf     : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    _cpswsprintf, offset szBuffer2, CTEXT("%u"), 123456789
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - _cpswsprintf : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  ;
  ; Hexa number display test
  ;
  invoke                    Write_Console, CTEXT(' * parameters: CTEXT("%08X"), 123456789.', 0Dh, 0Ah)
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    wsprintf, offset szBuffer2, CTEXT("%08X"), 123456789
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - wsprintf     : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    _cpswsprintf, offset szBuffer2, CTEXT("%08X"), 123456789
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - _cpswsprintf : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  ;
  ; Hexa number display test with leading 0x
  ;
  invoke                    Write_Console, CTEXT(' * parameters: CTEXT("%#08X"), 123456789.', 0Dh, 0Ah)
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    wsprintf, offset szBuffer2, CTEXT("%#08X"), 123456789
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - wsprintf     : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer
  counter_begin             LOOP_COUNT, NORMAL_PRIORITY_CLASS; HIGH_PRIORITY_CLASS
  invoke                    _cpswsprintf, offset szBuffer2, CTEXT("%#08X"), 123456789
  counter_end
  mov                       ebx, eax
  invoke                    wsprintf, offset szBuffer, CTEXT("   - _cpswsprintf : %5d cycles. (result: %s).", 0Dh, 0Ah), ebx, offset szBuffer2
  invoke                    Write_Console, offset szBuffer

  invoke                    ExitProcess, NULL

; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =                                                                           =
; =                         C O N S O L E   S T U F F                         =
; =                                                                           =
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Initialise console                                                    =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Init_Console                    Proc
  mov                       hConsoleOut, func(GetStdHandle, STD_OUTPUT_HANDLE)
  ret
Init_Console                    EndP

;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
;   = Write ascii text on colsole                                           =
;   =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Write_Console                   Proc   pAsciiText : PBYTE
  pushad
  mov                       edi, pAsciiText
  xor                       eax, eax
  xor                       ecx, ecx
  dec                       ecx
  repne                     scasb
  not                       ecx
  dec                       ecx
  invoke                    WriteConsoleA, hConsoleOut, pAsciiText, ecx, offset dConsoleRW, NULL
  popad
  ret
Write_Console                   EndP

End start
